/***************************************************/
/* Copyright (C) 1999 Yoneji Seto */
/* ѥǡե */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <glib.h>
#include "jyu.h"

#define P_DATA_FILE p_data_file
#define PFACT    0.3528

char *ps_string={"\
%!PS-Adobe-2.0\n\
% constants\n\
/ZEN { /Ryumin-Light-V findfont exch dup /FONTSIZE exch def scalefont setfont } def\n\
/HAN { /Courier-Bold findfont exch dup /FONTSIZE exch def scalefont setfont } def\n\
"
};

extern JYU *jyu_end;
extern char s_yban[], s_adr1[], s_adr2[], s_katagaki[], s_namae[];
extern char lpr_command[];
extern ATENA_DT atena_dt[];

static float  x_offset, y_offset;

/** Ⱦѡ(EUC)*******************************/
/**                                              **/
static char *han2zen(char *str)
{                  /*sp  !    "    #    $    %    &    '    (    )    *    +    ,    -    .    / */
  static char hi[]={0x21,0x21,0x21,0x21,0x21,0x21,0x21,0x21,0x21,0x21,0x21,0x21,0x21,0x21,0x21,0x21};
  static char lo[]={0x21,0x2a,0x37,0x74,0x70,0x73,0x75,0x2d,0x4a,0x4b,0x76,0x5c,0x22,0x3d,0x25,0x3f};

  static char buff[1024];
  static char jis_hex[1024*4];

  unsigned char s3[3], s1;
  int cnt, i, ch, j;

  cnt=strlen(str);
  cnt=0;
  i=0;
  while(str[cnt]){
    if (' '<=str[cnt] && '/'>=str[cnt]){
      ch=str[cnt] - ' ';
      buff[i++]=0x80 | hi[ch];
      buff[i++]=0x80 | lo[ch];
    }else if ('0'<=str[cnt] && 'z'>=str[cnt]){
      buff[i++]=0x80 | 0x23;
      buff[i++]=0x80 | (0x30+str[cnt]-'0');
    }else
      buff[i++]=str[cnt];
    cnt++;
  }   
  buff[i]='\0';

  cnt=0;
  for (j=0; j<i; j++){          /*EUC -> JIS*/
    s1=0x7f & buff[j];
    sprintf(s3, "%02X", s1);
    jis_hex[cnt++]=s3[0];
    jis_hex[cnt++]=s3[1];
  }
  jis_hex[cnt++]='\0';

  return jis_hex;
}
  
  
/** ʸ  ************************************/
/**                                              **/
static void str_out(char *str, FILE *fout, double x, double y, double size)
{
  int ix, iy, isize;

  ix=(int)((100 - x + x_offset)/PFACT);
  iy=(int)((297 - y + y_offset)/PFACT);
  isize=(int)(size/PFACT);
  
  fprintf(fout, "%d %d moveto\n", ix, iy);
  fprintf(fout, "%d ZEN\n", isize);
  fprintf(fout, "<%s>show\n", han2zen(str));
}

/** ֹ̾  *********************************/
/**                                              **/
static void bangou1_out(char *str, FILE *fout)
{
  int ix, iy, isize, i, j;
  double x, y;

  if (8!=strlen(str))
    return;

  x=55.7;
  y=20.0;
  j=0;

  for (i=0; i<8; i++){
    if (3==i){           /* - Ȥ*/
      j=0;
      x-=21.6;
      continue;
    } 
    ix=(int)((100 - x + x_offset + 7*j + 2.0)/PFACT);
    iy=(int)((297 - y + y_offset)/PFACT);
    isize=(int)(5.0/PFACT);
    j++;
  
    fprintf(fout, "%d %d moveto\n", ix, iy);
    fprintf(fout, "%d HAN\n", isize);
    fprintf(fout, "(%c)show\n", str[i]);
  }
}

/** пֹ  *******************************/
/**                                              **/
static void bangou2_out(char *str, FILE *fout, double x, double y)
{
  int ix, iy, isize, i, j;

  if (8!=strlen(str))
    return;

  j=0;
  for (i=0; i<8; i++){
    if (3==i){           /* - Ȥ*/
      j=0;
      x=81.0;
      continue;
    } 
    ix=(int)((100 - x + x_offset + 4*j + 2.0)/PFACT);
    iy=(int)((297 - y + y_offset)/PFACT);
    isize=(int)(4.0/PFACT);
    j++;

    fprintf(fout, "%d %d moveto\n", ix, iy);
    fprintf(fout, "%d HAN\n", isize);
    fprintf(fout, "(%c)show\n", str[i]);
  }
}

/** пͽ **************************************/
/**                                               **/
static void sasidasi_out(FILE *fp)
{
  bangou2_out(s_yban, fp, atena_dt[10].x, atena_dt[10].y),
  str_out(s_adr1, fp, atena_dt[6].x, atena_dt[6].y, atena_dt[6].f);
  str_out(s_adr2, fp, atena_dt[7].x, atena_dt[7].y, atena_dt[7].f);
  str_out(s_katagaki, fp, atena_dt[8].x, atena_dt[8].y, atena_dt[8].f);
  str_out(s_namae, fp, atena_dt[9].x, atena_dt[9].y, atena_dt[9].f);
}

/**   ***************************************/
/**                                               **/
static void ji_out(FILE *fp, JYU *jyu_p)
{
  char wk[1024];

  sprintf(wk, "%s%s", jyu_p->namae, jyu_p->ji_keisyou);
  bangou1_out(jyu_p->ji_yubin, fp);
  str_out(jyu_p->jitaku1, fp, atena_dt[1].x, atena_dt[1].y, atena_dt[1].f);
  str_out(jyu_p->jitaku2, fp, atena_dt[2].x, atena_dt[2].y, atena_dt[2].f);
  str_out(wk, fp, atena_dt[4].x, atena_dt[4].y, atena_dt[4].f);
  str_out(jyu_p->ji_ren1, fp, atena_dt[5].x, atena_dt[5].y, atena_dt[5].f);
  sasidasi_out(fp);
  fputs("showpage\n", fp);
}

/**   ***************************************/
/**                                               **/
static void ka_out(FILE *fp, JYU *jyu_p)
{
  char wk[1024];

  sprintf(wk, "%s%s", jyu_p->namae, jyu_p->ka_keisyou);
  bangou1_out(jyu_p->ka_yubin, fp);
  str_out(jyu_p->kaisya1, fp, atena_dt[1].x, atena_dt[1].y, atena_dt[1].f);
  str_out(jyu_p->kaisya2, fp, atena_dt[2].x, atena_dt[2].y, atena_dt[2].f);
  str_out(jyu_p->ka_katagaki, fp, atena_dt[3].x, atena_dt[3].y, atena_dt[3].f);
  str_out(wk, fp, atena_dt[4].x, atena_dt[4].y, atena_dt[4].f);
  sasidasi_out(fp);
  fputs("showpage\n", fp);
}

/** å *****************************/
/**                                               **/
void atena_chk_on_all(void)
{
  JYU *jyu_p;
  FILE *fp;

  atena_config_read();

  if (NULL==(fp=popen(lpr_command, "w")))
    return;

  //if (NULL==(fp=fopen("test.ps", "w")))
  //  return;

  x_offset=atena_dt[0].x;
  y_offset=atena_dt[0].y;

  fprintf(fp, "%s\n", ps_string);

  jyu_p=jyu_end;
  while(jyu_p){
    if (0==jyu_p->del){
      if (jyu_p->ji_atena)
	ji_out(fp, jyu_p);
      if (jyu_p->ka_atena)
	ka_out(fp, jyu_p);
    } 
    jyu_p=jyu_p->pb;
  }
  pclose(fp);
}

/** ΰå **********************/
/**                                               **/
void atena_chk_on_sach(void)
{
  JYU *jyu_p;
  FILE *fp;

  atena_config_read();

  if (NULL==(fp=popen(lpr_command, "w")))
    return;

  //if (NULL==(fp=fopen("test.ps", "w")))
  //  return;

  x_offset=atena_dt[0].x;
  y_offset=atena_dt[0].y;

  fprintf(fp, "%s\n", ps_string);

  jyu_p=jyu_end;
  while(jyu_p){
    if (0==jyu_p->del && 1==jyu_p->sach){
      if (jyu_p->ji_atena)
	ji_out(fp, jyu_p);
      if (jyu_p->ka_atena)
	ka_out(fp, jyu_p);
    } 
    jyu_p=jyu_p->pb;
  }
  pclose(fp);

}

/** ο **************************************/
/**                                               **/
void atena_sel_1(JYU *jyu_p)
{
  FILE *fp;

  atena_config_read();

  if (NULL==(fp=popen(lpr_command, "w")))
    return;

  //if (NULL==(fp=fopen("test.ps", "w")))
  //  return;

  x_offset=atena_dt[0].x;
  y_offset=atena_dt[0].y;

  fprintf(fp, "%s\n", ps_string);

  if (0==jyu_p->del){
    if (jyu_p->ji_atena)
      ji_out(fp, jyu_p);
    if (jyu_p->ka_atena)
      ka_out(fp, jyu_p);
  } 

  pclose(fp);
}


