/***************************************************/
/* Copyright (C) 1999 Yoneji Seto */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <glib.h>
#include "jyu.h"

#define ATENA_CONFIG_FILE ".atena_config_file"

static char *syoki_dt[11]={"-2,-16",          /*0 սΤΰ֤Ĵ*/
	       "15,30,5",          /*1 ν꣱ΰ֤ȥեȥñ̤ϥߥ*/
	       "22,35,5",          /*2 ꣲ*/
	       "32,30,5",          /*3 */
	       "40,40,8",          /*4 ̾*/
               "50,50,8",          /*5 Ϣ̾*/
	       "65,70,3.5",        /*6 пͤν꣱*/
	       "69,70,3.5",        /*7 ꣲ*/
	       "73,70,3.5",        /*8 */
	       "77,77,3.5",        /*9 ̾*/
	       "94.5,144"};        /*10 пͤ͹ֹΰ*/

static int destroy_on, dialog_loop, ok_button;
static GtkWidget *yban, *adr1, *adr2, *katagaki, *namae, *xyw[11], *lpr;

char s_yban[128], s_adr1[128], s_adr2[128], s_katagaki[128], s_namae[128];
char lpr_command[128];
ATENA_DT atena_dt[11];

/** 1Խ ****************************************/
/**  0=ok 1=err                                  **/
static int line_out(char *buff, FILE *fp)
{
  if (EOF==fputs(buff, fp))
    return 1;
  if (EOF==fputs("\n", fp))
    return 1;
  return 0;
}

/** 1 ****************************************/
/**                                              **/
static char *line_read(char *buff, FILE *fp)
{
  int cnt;

  if (NULL==fgets(buff, 128, fp))
    return NULL;
  if (0 < (cnt=strlen(buff)))
    buff[cnt-1]='\0';
  return buff;
}

/**̾ǡɤ߹ ʤк **********************/
/** ret 1=err 0=ok                                    **/
int atena_config_read(void)
{
  FILE *fp;
  int  i;

  if (access(ATENA_CONFIG_FILE, F_OK) != 0){
    fp=fopen(ATENA_CONFIG_FILE, "w");
    for (i=0; i<5; i++)
      line_out("", fp);
    line_out("lpr -Pps", fp);
    for (i=0; i<11; i++)
      line_out(syoki_dt[i], fp);
    fclose(fp);
  }
  fp=fopen(ATENA_CONFIG_FILE, "r");

  if (!line_read(s_yban, fp))  
     return 1;
  if (!line_read(s_adr1, fp))  
     return 1;
  if (!line_read(s_adr2, fp))  
     return 1;
  if (!line_read(s_katagaki, fp))  
     return 1;
  if (!line_read(s_namae, fp))  
     return 1;
  if (!line_read(lpr_command, fp))  
     return 1;

  if (2!=fscanf(fp, "%f,%f\n", &atena_dt[0].x, &atena_dt[0].y))
    sscanf(syoki_dt[0], "%f,%f\n", &atena_dt[0].x, &atena_dt[0].y);
  for (i=1; i<10; i++){
    if (3!=fscanf(fp, "%f,%f,%f\n", &atena_dt[i].x, &atena_dt[i].y, &atena_dt[i].f))
      sscanf(syoki_dt[i], "%f,%f\n", &atena_dt[i].x, &atena_dt[i].y);
  }

  if (2!=fscanf(fp, "%f,%f\n", &atena_dt[10].x, &atena_dt[10].y))
    sscanf(syoki_dt[10], "%f,%f\n", &atena_dt[10].x, &atena_dt[10].y);
    
  fclose(fp);
  return 0;
}

/** ǡɽ ******************************************/
/**                                                   **/
static void dt_view(void)
{
  char buff[128];
  int  i;

  gtk_entry_set_text(GTK_ENTRY(yban), s_yban);
  gtk_entry_set_text(GTK_ENTRY(adr1), s_adr1);
  gtk_entry_set_text(GTK_ENTRY(adr2), s_adr2);
  gtk_entry_set_text(GTK_ENTRY(katagaki), s_katagaki);
  gtk_entry_set_text(GTK_ENTRY(namae), s_namae);
  gtk_entry_set_text(GTK_ENTRY(lpr), lpr_command);

  sprintf(buff, "%4.1f, %4.1f", atena_dt[0].x, atena_dt[0].y);
  gtk_entry_set_text(GTK_ENTRY(xyw[0]), buff);
  for (i=1; i<10; i++){
    sprintf(buff, "%4.1f, %4.1f, %4.1f", atena_dt[i].x, atena_dt[i].y, atena_dt[i].f);
    gtk_entry_set_text(GTK_ENTRY(xyw[i]), buff);
  }
  sprintf(buff, "%4.1f, %4.1f", atena_dt[10].x, atena_dt[10].y);
  gtk_entry_set_text(GTK_ENTRY(xyw[10]), buff);
}

/** ᤹ ******************************************/
/**                                                   **/
static void syokichi_cb(void)
{
  unlink(ATENA_CONFIG_FILE);
  atena_config_read();
  dt_view();
}

/*******************************************************/
/* destroy */
static void destroy_cb(GtkWidget *widget, gpointer data)
{
  dialog_loop=0;
  destroy_on=1;
}

/********************************************************/
/* ok_callback */
static void ok_cb(GtkWidget *widget, gpointer data)
{
  dialog_loop=0;
  ok_button=1;
}

/********************************************************/
/* cancel_cllback */
static void cancel_cb(GtkWidget *widget, gpointer data)
{
  dialog_loop=0;
  ok_button=0;
}

/** ̾ ********************************/
/**                                             **/
void atena_set(GtkWidget *main_window)
{
  GtkWidget *window, *vbox, *hbox, *label, *button;

  int i;
  char buff[128];
  FILE *fp;

  gtk_widget_set_sensitive(main_window, 0);

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(window),  "̾");
  gtk_container_border_width (GTK_CONTAINER (window), 10);
  gtk_signal_connect(GTK_OBJECT(window), "destroy", 
		     GTK_SIGNAL_FUNC(destroy_cb), NULL);

  vbox=gtk_vbox_new(FALSE, 0);
  gtk_widget_show(vbox);
  gtk_container_add (GTK_CONTAINER(window), vbox);

  hbox=gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
  gtk_widget_show(hbox);

  label=gtk_label_new("        п ̾");
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 10);
  gtk_widget_show(label);

  hbox=create_hbox(vbox);
  yban=create_field(hbox, "͹ֹ");

  hbox=create_hbox(vbox);
  adr1=create_field(hbox, "  ");

  hbox=create_hbox(vbox);
  adr2=create_field(hbox, "      ");

  hbox=create_hbox(vbox);
  katagaki=create_field(hbox, "  ");

  hbox=create_hbox(vbox);
  namae=create_field(hbox, "̾  ");

  hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 10);
  gtk_widget_show(hbox);

  hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 10);
  gtk_widget_show(hbox);

  hbox=create_hbox(vbox);
  lpr=create_field(hbox, "ޥ");

  hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 10);
  gtk_widget_show(hbox);

  hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
  gtk_widget_show(hbox);

  label=gtk_label_new("                 (x,y) , (mm)");
  gtk_box_pack_end(GTK_BOX(hbox), label, FALSE, FALSE, 5);
  gtk_widget_show(label);

  hbox=create_hbox(vbox);
  xyw[0]=create_field(hbox, "ΰ  Ĵ");
  hbox=create_hbox(vbox);
  xyw[1]=create_field(hbox, "̾꣱");
  hbox=create_hbox(vbox);
  xyw[2]=create_field(hbox, "        ");
  hbox=create_hbox(vbox);
  xyw[3]=create_field(hbox, "          ");
  hbox=create_hbox(vbox);
  xyw[4]=create_field(hbox, "          ̾");
  hbox=create_hbox(vbox);
  xyw[5]=create_field(hbox, "          Ϣ̾");
  hbox=create_hbox(vbox);
  xyw[6]=create_field(hbox, "ʬ꣱");
  hbox=create_hbox(vbox);
  xyw[7]=create_field(hbox, "        ");
  hbox=create_hbox(vbox);
  xyw[8]=create_field(hbox, "          ");
  hbox=create_hbox(vbox);
  xyw[9]=create_field(hbox, "          ̾");
  hbox=create_hbox(vbox);
  xyw[10]=create_field(hbox, "ʬ  ͹ֹ");


  hbox = gtk_hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 10);
  gtk_widget_show(hbox);

  hbox=create_hbox(vbox);
  button = gtk_button_new_with_label("ǥեȤ᤹");
  gtk_box_pack_end(GTK_BOX(hbox), button, FALSE, FALSE, 10);
  gtk_signal_connect (GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(syokichi_cb), NULL);
  gtk_widget_show(button);

  button = gtk_button_new_with_label("󥻥");
  gtk_box_pack_end(GTK_BOX(hbox), button, FALSE, FALSE, 10);
  gtk_signal_connect (GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(cancel_cb), NULL);
  gtk_widget_show(button);

  button = gtk_button_new_with_label("    OK    ");
  gtk_box_pack_end(GTK_BOX(hbox), button, FALSE, FALSE, 10);
  gtk_signal_connect (GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(ok_cb), NULL);
  gtk_widget_show(button);

  gtk_widget_show(window);

  atena_config_read();
  dt_view();

  destroy_on=0;
  ok_button=0;
  dialog_loop=1;
  while(dialog_loop)
    gtk_main_iteration();

  if (ok_button){
    if (NULL==(fp=fopen(ATENA_CONFIG_FILE, "w")))
      return;
    strncpy(s_yban, gtk_entry_get_text(GTK_ENTRY(yban)), sizeof(s_yban));
    line_out(s_yban, fp);
    strncpy(s_adr1, gtk_entry_get_text(GTK_ENTRY(adr1)), sizeof(s_adr1));
    line_out(s_adr1, fp);
    strncpy(s_adr2, gtk_entry_get_text(GTK_ENTRY(adr2)), sizeof(s_adr2));
    line_out(s_adr2, fp);
    strncpy(s_katagaki, gtk_entry_get_text(GTK_ENTRY(katagaki)), sizeof(s_katagaki));
    line_out(s_katagaki, fp);
    strncpy(s_namae, gtk_entry_get_text(GTK_ENTRY(namae)), sizeof(s_namae));
    line_out(s_namae, fp);
    strncpy(lpr_command, gtk_entry_get_text(GTK_ENTRY(lpr)), sizeof(lpr_command));
    line_out(lpr_command, fp);

    for (i=0; i<11; i++){
      strncpy(buff, gtk_entry_get_text(GTK_ENTRY(xyw[i])), sizeof(buff));
      line_out(buff, fp);
    }
    fclose(fp);
  }

  if (!destroy_on)
    gtk_widget_destroy(window);

  gtk_widget_set_sensitive(main_window, 1);
}
